diff --git a/cdist/conf/type/__package_update_index/explorer/currage b/cdist/conf/type/__package_update_index/explorer/currage
index e86e3f13..45653f91 100644
--- a/cdist/conf/type/__package_update_index/explorer/currage
+++ b/cdist/conf/type/__package_update_index/explorer/currage
@@ -17,17 +17,17 @@
# You should have received a copy of the GNU General Public License
# along with cdist. If not, see .
-os="$("$__explorer/os")"
+type="$($__type_explorer/type)"
-case "$os" in
- debian|ubuntu|devuan)
+case "$type" in
+ apt)
if [ -f "/var/cache/apt/pkgcache.bin" ]; then
echo $(($(date +"%s")-$(stat --format '%Y' /var/cache/apt/pkgcache.bin)))
else
echo 0
fi
;;
- *) echo "Your operating system ($os) is currently not supported by this type (${__type##*/})." >&2
+ *) echo "Your specified type ($type) is currently not supported." >&2
echo "Please contribute an implementation for it if you can." >&2
;;
esac
diff --git a/cdist/conf/type/__package_update_index/explorer/type b/cdist/conf/type/__package_update_index/explorer/type
new file mode 100644
index 00000000..805b9f04
--- /dev/null
+++ b/cdist/conf/type/__package_update_index/explorer/type
@@ -0,0 +1,34 @@
+#!/bin/sh
+#
+# 2018 Stu Zhao (z12y12l12 at gmail.com)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+
+if [ -f "$__object/parameter/type" ]; then
+ cat "$__object/parameter/type"
+else
+ # By default determine package manager based on operating system
+ os="$($__explorer/os)"
+ case "$os" in
+ amazon|scientific|centos|fedora|redhat) echo "yum" ;;
+ debian|ubuntu|devuan) echo "apt" ;;
+ archlinux) echo "pacman" ;;
+ *)
+ echo "Don't know how to manage packages on: $os" >&2
+ exit 1
+ ;;
+ esac
+fi
diff --git a/cdist/conf/type/__package_update_index/gencode-remote b/cdist/conf/type/__package_update_index/gencode-remote
index 37bfe7ab..132a3daa 100755
--- a/cdist/conf/type/__package_update_index/gencode-remote
+++ b/cdist/conf/type/__package_update_index/gencode-remote
@@ -21,28 +21,12 @@
# Update the package index with the appropriate package manager
#
-type="$__object/parameter/type"
+type=$(cat "$__object/explorer/type")
if [ -f "$__object/parameter/maxage" ]; then
maxage="$(cat "$__object/parameter/maxage")"
currage="$(cat "$__object/explorer/currage")"
fi
-if [ -f "$type" ]; then
- type="$(cat "$type")"
-else
- # By default determine package manager based on operating system
- os="$(cat "$__global/explorer/os")"
- case "$os" in
- amazon|scientific|centos|fedora|redhat) type="yum" ;;
- debian|ubuntu|devuan) type="apt" ;;
- archlinux) type="pacman" ;;
- *)
- echo "Don't know how to manage packages on: $os" >&2
- exit 1
- ;;
- esac
-fi
-
if [ -n "$maxage" ] && [ "$type" != "apt" ]; then
echo "ERROR: \"--maxage\" only supported for \"apt\" pkg-manager." >&2
exit 1